#include <bits/stdc++.h>

using namespace std;

int stene[100][100];
int tokReke[100][100];

int main()
{
    int n, h; cin>>n>>h;

    for(int i = 0; i < h; i++)
    {
        for(int j = 0; j < n; j++)
        {
            cin>>stene[j][i];
            if(i == 0) tokReke[j][i]++;
            else tokReke[j][i] += tokReke[j][i-1];

            //cout<<"n je "<<j<<", a tokReke sada je "<<tokReke[0][i]<<" "<<tokReke[1][i]<<" "<<tokReke[2][i]<<endl;

            if(stene[j][i] == 0)
            {
                if((i+1)%2 == 1)
                {
                    if(j == 0) tokReke[j+1][i] += tokReke[j][i];
                    else if(j == n-1) tokReke[j-1][i] += tokReke[j][i];
                    else
                    {
                        if(tokReke[j][i]%2 == 1) tokReke[j-1][i] += tokReke[j][i]/2 + 1;
                        else tokReke[j-1][i] += tokReke[j][i]/2;

                        tokReke[j+1][i] += tokReke[j][i]/2;
                    }

                    tokReke[j][i] = 0;

                    //cout<<"n je "<<j<<", a tokReke sada je"<<tokReke[j-1][i]<<" "<<tokReke[j][i]<<" "<<tokReke[j+1][i]<<endl;
                }
                else
                {
                    if(j == 0) tokReke[j+1][i] += tokReke[j][i];
                    else if(j == n-1) tokReke[j-1][i] += tokReke[j][i];
                    else
                    {
                        if(tokReke[j][i]%2 == 1) tokReke[j+1][i] += tokReke[j][i]/2 + 1;
                        else tokReke[j+1][i] += tokReke[j][i]/2;

                        tokReke[j-1][i] += tokReke[j][i]/2;
                    }

                    tokReke[j][i] = 0;

                    //cout<<"n je "<<j<<", a tokReke sada je"<<tokReke[j-1][i]<<" "<<tokReke[j][i]<<" "<<tokReke[j+1][i]<<endl;
                }

                //cout<<"n je "<<j<<", a tokReke sada je"<<tokReke[j-1][i]<<" "<<tokReke[j][i]<<" "<<tokReke[j+1][i]<<endl;
            }
            //else tokReke[j][i]++;

            //cout<<"n je "<<j<<", a tokReke sada je "<<tokReke[0][i]<<" "<<tokReke[1][i]<<" "<<tokReke[2][i]<<endl;
        }
    }

    for(int i = 0; i < n; i++) cout<<tokReke[i][h-1]<<" ";

    return 0;
}